#ifndef VIEWS_LOCATION_H
#define VIEWS_LOCATION_H

#include "../View.h"

#include "../Data/Location.h"

#include <Lum/Model/Action.h>

#include <Lum/Panel.h>
#include <Lum/String.h>

namespace Views {

  class Location : public ::Base::DataView
  {
  private:
    ::Data::Location      *location;

    Lum::Panel            *panel;

    Lum::Model::StringRef street;
    Lum::Model::StringRef city;
    Lum::Model::StringRef zip;
    Lum::Model::StringRef state;
    Lum::Model::StringRef country;

  public:
    Location();

    void RegisterDataViews(Lum::Tab*& tab);

    void Resync(Lum::Base::Model* model, const Lum::Base::ResyncMsg& msg);

    void Load(::Base::View::DataPtr viewData=NULL);
    void Vanish();
    void Save();
  };

}

#endif
